//**************************  interpreter.cpp   ***********************

#include <ctype.h>
#include "interpreter.h"

double Statement::findValue(char *id) {
    IdNode tmp(id);
    list<IdNode>::iterator i = find(idList.begin(),idList.end(),tmp);
    if (i != idList.end())
         return i->value;
    else issueError("Nieznana zmienna");
    return 0;  // ta instrukcja nigdy nie bdzie wykonana
}

void Statement::processNode(char* id ,double e) {
    IdNode tmp(id,e);
    list<IdNode>::iterator i = find(idList.begin(),idList.end(),tmp);
    if (i != idList.end())
         i->value = e;
    else idList.push_front(tmp);
}

// readId() odczytuje acuchy liter i cyfr zaczynajce si liter,
// zapisuje je w tablicy przekazanej w parametrze.
// Przykadowe identyfikatory: var1, x, pqr123xyz, aName i tak dalej.

void Statement::readId(char *id) {
    int i = 0;
    if (isspace(ch))
         cin >> ch;       // pomijaj biae znaki
    if (isalpha(ch)) {
         while (isalnum(ch)) {
             id[i++] = ch;
             cin.get(ch); // nie pomijaj biaych znakw
         }
         id[i] = '\0';
    }
    else issueError("Oczekiwano identyfikatora");
}

double Statement::factor() {
    double var, minus = 1.0;
    static char id[200];
    cin >> ch;
    while (ch == '+' || ch == '-') {      // pobierz wszystkie + i -
        if (ch == '-')
            minus *= -1.0;
        cin >> ch;
    }
    if (isdigit(ch) || ch == '.') {      // Czynnik moe by liczb
         cin.putback(ch);
         cin >> var >> ch;
    }
    else if (ch == '(') {                  // lub wyraeniem w nawiasie
         var = expression();
         if (ch == ')')
              cin >> ch;
         else issueError("Brak prawego nawiasu");
    }
    else {
         readId(id);                          // lub identyfikaorem
         if (isspace(ch))
             cin >> ch;
         var = findValue(id);
    }
    return minus * var;
}

double Statement::term() {
    double f = factor();
    while (true) {
        switch (ch) {
            case '*' : f *= factor(); break;
            case '/' : f /= factor(); break;
            default  : return f;
        }
    }
}

double Statement::expression() {
    double t = term();
    while (true) {
        switch (ch) {
            case '+' : t += term(); break;
            case '-' : t -= term(); break;
            default  : return t;
        }
    }
}

void Statement::getStatement() {
    char id[20], command[20];
    double e;
    cout << "Podaj instrukcj: ";
    cin  >> ch;
    readId(id);
    strcpy(command,id);
    for (int i = 0; i < strlen(command); i++)
	command[i] = toupper(command[i]);
    if (strcmp(command,"STATUS") == 0)
         cout << *this;
    else if (strcmp(command,"PRINT") == 0) {
         readId(id);
         cout << id << " = " << findValue(id) << endl;
    }
    else if (strcmp(command,"END") == 0)
         exit(0);
    else {
         if (isspace(ch))
             cin >> ch;
         if (ch == '=') {
              e = expression();
              if (ch != ';')
                   issueError("Instrukcja zawiera zbdne znaki.");
              else processNode(id,e);
         }
         else issueError("Brak '='.");
    }
}

